Imports FirstFloor.ModernUI.Windows
Imports OmicronLab.TicroControl.Helper
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Imaging
Imports System.Windows.Navigation
Imports System.Windows.Shapes
Imports Newtonsoft.Json.Linq

Namespace OmicronLab.TicroControl.Content.Live.PtpPages
	''' <summary>
	''' Interaction logic for Time.xaml
	''' </summary>
	Partial Public Class Time
		Inherits UserControl
		Implements IContent
		Private isUpdating As Boolean = False
		Private updateTimer As System.Timers.Timer = Nothing

		''' <summary>Initializes a new instance of the <see cref="Time"/> class.</summary>
		Public Sub New()
			InitializeComponent()
		End Sub

		''' <summary>Called when navigation to a content fragment begins.</summary>
		''' <param name="e">An object that contains the navigation data.</param>
		Public Sub OnFragmentNavigation(e As FirstFloor.ModernUI.Windows.Navigation.FragmentNavigationEventArgs) Implements IContent.OnFragmentNavigation
		End Sub

		''' <summary>Called when this instance is no longer the active content in a frame.</summary>
		''' <param name="e">An object that contains the navigation data.</param>
		''' <exception cref="System.NotImplementedException"></exception>
		Public Sub OnNavigatedFrom(e As FirstFloor.ModernUI.Windows.Navigation.NavigationEventArgs) Implements IContent.OnNavigatedFrom
		End Sub

		''' <summary>Called when a this instance becomes the active content in a frame.</summary>
		''' <param name="e">An object that contains the navigation data.</param>
		''' <exception cref="System.NotImplementedException"></exception>
		Public Sub OnNavigatedTo(e As FirstFloor.ModernUI.Windows.Navigation.NavigationEventArgs) Implements IContent.OnNavigatedTo
			If updateTimer Is Nothing Then
				updateTimer = New System.Timers.Timer(500)
				updateTimer.AutoReset = True
				AddHandler updateTimer.Elapsed, Sub(s, arg)
													Try
														If Not isUpdating Then
															isUpdating = True
															UpdateValuesAsync().Wait()
															isUpdating = False
														End If
													Catch exp As AggregateException
														If Not (TypeOf exp.InnerException Is TaskCanceledException) Then
															Throw
														End If
													Catch generatedExceptionName As TaskCanceledException
													End Try
												End Sub
			End If
			updateTimer.Enabled = True
			Task.Run(Sub() UpdateValuesAsync().Wait())
		End Sub

		''' <summary>Called just before this instance is no longer the active content in a frame.</summary>
		''' <param name="e">An object that contains the navigation data.</param>
		''' <remarks>The method is also invoked when parent frames are about to navigate.</remarks>
		Public Sub OnNavigatingFrom(e As FirstFloor.ModernUI.Windows.Navigation.NavigatingCancelEventArgs) Implements IContent.OnNavigatingFrom
			If updateTimer IsNot Nothing Then
				updateTimer.Enabled = False
			End If
		End Sub

		''' <summary>Updates the values.</summary>
		''' <returns></returns>
		Private Async Function UpdateValuesAsync() As Task
			'Download the JSON from the device and parse it - the example uses JSON.net
			Dim ptp As JObject = Await DownloadHelper.DownloadJsonAsync("ptpStatus.php")
			'ptpStatus contains the current state of the PTP daemon
			Dispatcher.Invoke(Sub()
								  'The values can then be accessed as strings as followed
								  labelUtcOffset.Content = ptp("time")("utcOffset")
								  labelUtcOffsetValid.Content = ptp("time")("utcOffsetValid")
								  labelLeap59.Content = ptp("time")("leap59")
								  labelLeap61.Content = ptp("time")("leap61")
								  labelTimeTraceable.Content = ptp("time")("timeTraceable")
								  labelFrequencyTraceable.Content = ptp("time")("frequencyTraceable")
								  labelPtpTimeScale.Content = ptp("time")("ptpTimescale")
								  labelTimeSource.Content = ptp("time")("timeSource")
							  End Sub)
		End Function
	End Class
End Namespace
