Imports FirstFloor.ModernUI.Windows
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Imaging
Imports System.Windows.Navigation
Imports System.Windows.Shapes

Namespace OmicronLab.TicroControl.Content.OutputStatus
	''' <summary>
	''' Interaction logic for Overview.xaml
	''' </summary>
	Partial Public Class Overview
		Inherits UserControl
		Implements IContent
		''' <summary>Gets the refresh command.</summary>
		''' <value>The refresh command.</value>
		Public Property RefreshCommand() As AwaitableDelegateCommand
			Get
				Return m_RefreshCommand
			End Get
			Private Set(value As AwaitableDelegateCommand)
				m_RefreshCommand = value
			End Set
		End Property
		Private m_RefreshCommand As AwaitableDelegateCommand

		''' <summary>Initializes a new instance of the <see cref="Overview"/> class.</summary>
		Public Sub New()
			RefreshCommand = New AwaitableDelegateCommand(AddressOf RefreshValuesAsync)
			InitializeComponent()
		End Sub

		''' <summary>Called when navigation to a content fragment begins.</summary>
		''' <param name="e">An object that contains the navigation data.</param>
		Public Sub OnFragmentNavigation(e As FirstFloor.ModernUI.Windows.Navigation.FragmentNavigationEventArgs) Implements IContent.OnFragmentNavigation
		End Sub

		''' <summary>Called when this instance is no longer the active content in a frame.</summary>
		''' <param name="e">An object that contains the navigation data.</param>
		''' <exception cref="System.NotImplementedException"></exception>
		Public Sub OnNavigatedFrom(e As FirstFloor.ModernUI.Windows.Navigation.NavigationEventArgs) Implements IContent.OnNavigatedFrom
		End Sub

		''' <summary>Called when a this instance becomes the active content in a frame.</summary>
		''' <param name="e">An object that contains the navigation data.</param>
		''' <exception cref="System.NotImplementedException"></exception>
		Public Sub OnNavigatedTo(e As FirstFloor.ModernUI.Windows.Navigation.NavigationEventArgs) Implements IContent.OnNavigatedTo
			Task.Run(Sub() RefreshCommand.Execute(Nothing))
		End Sub

		''' <summary>Called just before this instance is no longer the active content in a frame.</summary>
		''' <param name="e">An object that contains the navigation data.</param>
		''' <remarks>The method is also invoked when parent frames are about to navigate.</remarks>
		Public Sub OnNavigatingFrom(e As FirstFloor.ModernUI.Windows.Navigation.NavigatingCancelEventArgs) Implements IContent.OnNavigatingFrom
		End Sub

		''' <summary>Refreshes the values asynchronous.</summary>
		''' <returns></returns>
		Private Async Function RefreshValuesAsync() As Task
			If App.ApiClient Is Nothing Then
				Return
			End If

			'Query the soap interface for the output status - "Dim outputsStatus = App.ApiClient.GetOuputStatus()" executes the same synchronously
			Dim outputsStatus As TicroService.GetOuputStatusResponse = Await App.ApiClient.GetOuputStatusAsync()

			Dispatcher.Invoke(Sub()
								  'if queried asynchronous the array with the configuration values can be accessed at "outputsStatus.Body.GetOuputStatusResult"
								  'when queried synchronous the array is returned directly
								  labelStatusOutput1.Content = outputsStatus.Body.GetOuputStatusResult(0).FriendlyName
								  labelStatusOutput1.Foreground = If(outputsStatus.Body.GetOuputStatusResult(0).Mute, Brushes.Orange, Brushes.Black)

								  labelStatusOutput2.Content = outputsStatus.Body.GetOuputStatusResult(1).FriendlyName
								  labelStatusOutput2.Foreground = If(outputsStatus.Body.GetOuputStatusResult(1).Mute, Brushes.Orange, Brushes.Black)

								  labelStatusOutput3.Content = outputsStatus.Body.GetOuputStatusResult(2).FriendlyName
								  labelStatusOutput3.Foreground = If(outputsStatus.Body.GetOuputStatusResult(2).Mute, Brushes.Orange, Brushes.Black)

								  labelStatusOutput4.Content = outputsStatus.Body.GetOuputStatusResult(3).FriendlyName
								  labelStatusOutput4.Foreground = If(outputsStatus.Body.GetOuputStatusResult(3).Mute, Brushes.Orange, Brushes.Black)

								  labelStatusOutput5.Content = outputsStatus.Body.GetOuputStatusResult(4).FriendlyName
								  labelStatusOutput5.Foreground = If(outputsStatus.Body.GetOuputStatusResult(4).Mute, Brushes.Orange, Brushes.Black)
							  End Sub)
		End Function
	End Class
End Namespace
